Subject: Re: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

From: "Adrian Farrel" <[email-masked]>
Date: Thu, 16 Nov 2017 05:35:09 -0000

Let's unpick a couple of things...
 
1. This work is not talking about per-flow accounting, it is talking about peer SR-path accounting
2. ipfix on its own does not cut it because you still have to put a marker in the packets
3. Yes, SR assumes there is no (i.e. zero) state per SR-path in the network
But this third point causes a tension: we want to use SR because it is good, but we want to do transit node diagnostics because (frankly) they are necessary.
To get the full picture of why they are necessary read the draft, or consider ECMP.
 
This discussion will not be unfamiliar to those who tried to debug LDP networks.
 
Adrian

---

From: Robert Raszuk <[email-masked]>
Date: Thu, 16 Nov 2017 08:07:31 +0100

Adrian

I do not agree with with #2 .. no marker of any sort is needed.

And debugging LDP networks is no different then debugging IP networks so
sure some who are used to ATM/Frame Relay find it very hard to troubleshoot.

Best
r.

On Nov 16, 2017 13:35, "Adrian Farrel" <[email-masked]> wrote:

1. This work is not talking about per-flow accounting, it is talking about
peer SR-path accounting

2. ipfix on its own does not cut it because you still have to put a marker
in the packets

But this third point causes a tension: we want to use SR because it is
good, but we want to do transit node diagnostics because (frankly) they are
necessary.

To get the full picture of why they are necessary read the draft, or
consider ECMP.

This discussion will not be unfamiliar to those who tried to debug LDP
networks.

Adrian

---

From: <[email-masked]>
Date: Thu, 16 Nov 2017 09:43:51 +0000

Adrian,

to me, there’s no ideal solution. But an analysis may help to find a useful solution. There’s a need to collect traffic statistics also for packets which don’t follow the shortest end to end path. There’s no simple howto, I think.

For the time being, I’d prefer not to add special labels to the stack. What other options are there?

  *   Accounting at the router pushing a relevant label stack only.
  *   Accounting of an n-label stack.
  *   Acoounting of a subset of labels only (e.g. Node-SID Labels and Anycast-SID, but not ADJ-SID). The idea is a compromise to limit the number of counters be maintained. Consider accounting of the top 2 labels carrying global routing information.
  *   A special label. Shradda proposes to put such a label into the stack. The labels present there prior to the addition are maintained. One might think about a single top label which identifies and replaces the label stack carrying routing information relevant for the path. That would simplify accounting, but it requires suitable IGP functionality.

None of the options sounds simple. Are there more (and simpler) ones I didn’t come upon?

Regards, Ruediger

Von: spring [mailto:[email-masked]] Im Auftrag von Adrian Farrel
Gesendet: Donnerstag, 16. November 2017 06:35
An: 'Mach Chen' <[email-masked]>; 'Jeff Tantsura' <[email-masked]>; 'Robert Raszuk' <[email-masked]>
Cc: 'draft-hegde-spring-traffic-accounting-for-sr-paths' <[email-masked]>; 'spring' <[email-masked]>; 'Zafar Ali (zali)' <[email-masked]>; 'mpls' <[email-masked]>
Betreff: Re: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Adrian

---

From: John E Drake <[email-masked]>
Date: Thu, 16 Nov 2017 11:59:35 +0000

Ruediger,

There is also the possibility of using a GAL w/ a new fixed size GACH containing the SR Segment List Id.  This is similar to Robert’s suggestion of using a VXLAN header.

Yours Irrespectively,

John

From: mpls [mailto:[email-masked]] On Behalf Of [email-masked]
Sent: Thursday, November 16, 2017 4:44 AM
To: [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [mpls] [spring] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Adrian,

For the time being, I’d prefer not to add special labels to the stack. What other options are there?
-        Accounting at the router pushing a relevant label stack only.
-        Accounting of an n-label stack.
-        Acoounting of a subset of labels only (e.g. Node-SID Labels and Anycast-SID, but not ADJ-SID). The idea is a compromise to limit the number of counters be maintained. Consider accounting of the top 2 labels carrying global routing information.
-        A special label. Shradda proposes to put such a label into the stack. The labels present there prior to the addition are maintained. One might think about a single top label which identifies and replaces the label stack carrying routing information relevant for the path. That would simplify accounting, but it requires suitable IGP functionality.

Regards, Ruediger

Von: spring [mailto:[email-masked]] Im Auftrag von Adrian Farrel
Gesendet: Donnerstag, 16. November 2017 06:35
An: 'Mach Chen' <[email-masked]<mailto:[email-masked]>>; 'Jeff Tantsura' <[email-masked]<mailto:[email-masked]>>; 'Robert Raszuk' <[email-masked]<mailto:[email-masked]>>
Cc: 'draft-hegde-spring-traffic-accounting-for-sr-paths' <[email-masked]<mailto:[email-masked]>>; 'spring' <[email-masked]<mailto:[email-masked]>>; 'Zafar Ali (zali)' <[email-masked]<mailto:[email-masked]>>; 'mpls' <[email-masked]<mailto:[email-masked]>>
Betreff: Re: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Adrian

---

From: Alexander Vainshtein <[email-masked]>
Date: Thu, 16 Nov 2017 12:27:57 +0000

John,
Looks like a very interesting proposal.
Please note that GAL and GACH would not (hopefully) affect ECMP (if it is used on the label stack hashing) while the proposal in draft-hegde by and of itself does not guarantee that: the reserved label would be skipped, but the ID “labels” could be taken for real labels by the hashing function...

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]

From: spring [mailto:[email-masked]] On Behalf Of John E Drake
Sent: Thursday, November 16, 2017 2:00 PM
To: Ext - [email-masked] <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Ruediger,

Yours Irrespectively,

John

From: mpls [mailto:[email-masked]] On Behalf Of [email-masked]<mailto:[email-masked]>
Sent: Thursday, November 16, 2017 4:44 AM
To: [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [mpls] [spring] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Adrian,

Regards, Ruediger

Adrian

___________________________________________________________________________

This e-mail message is intended for the recipient only and contains information which is 
CONFIDENTIAL and which may be proprietary to ECI Telecom. If you have received this 
transmission in error, please inform us by e-mail, phone or fax, and then delete the original 
and all copies thereof.
___________________________________________________________________________

---

From: <[email-masked]>
Date: Thu, 16 Nov 2017 12:35:31 +0000

John,

that’s not what I’m looking for. What I’m looking for is traffic statistics collected at transit nodes. These statistics should reveal the true end-to-end traffic demand within the MPLS domain. The collection of statistics shouldn’t add complexity. A low number of counters helps to simplify collection and post-processing.

If I’m not entirely wrong, this discussion at least partially discusses different ways how to define what kind of flow to account and where and how to capture related statistics. In that case I prefer a collection of a broader set of requirements and possible solutions. If our ongoing discussion doesn’t identify a set of useful options (I’m not sure whether all contributors to the discussion require the same here), a draft collecting different requirements and solutions may be helpful.

Regards,

Ruediger

Von: John E Drake [mailto:[email-masked]]
Gesendet: Donnerstag, 16. November 2017 13:00
An: Geib, Rüdiger <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Betreff: RE: [mpls] [spring] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: John E Drake <[email-masked]>
Date: Thu, 16 Nov 2017 12:44:14 +0000

Sasha,

That’s a very good point.  Including the SR Segment List Ids could have the effect of disturbing the traffic flows away from the link in question.

Yours Irrespectively,

John

From: Alexander Vainshtein [mailto:[email-masked]]
Sent: Thursday, November 16, 2017 7:28 AM
To: John E Drake <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]; Ext - [email-masked] <[email-masked]>; [email-masked]; Michael Gorokhovsky <[email-masked]>
Subject: RE: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

John,

Regards,
Sasha

Office: +972-39266302
Cell:      +972-549266302
Email:   [email-masked]<mailto:[email-masked]>

From: spring [mailto:[email-masked]] On Behalf Of John E Drake
Sent: Thursday, November 16, 2017 2:00 PM
To: Ext - [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>
Cc: [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: John E Drake <[email-masked]>
Date: Thu, 16 Nov 2017 12:49:26 +0000

Ruediger,

It was just another alternative which does have the property of not disturbing path through an SR network of a packet in which it is included.

Yours Irrespectively,

John

From: [email-masked] [mailto:[email-masked]]
Sent: Thursday, November 16, 2017 7:36 AM
To: John E Drake <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: AW: [mpls] [spring] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

John,

Regards,

Ruediger

An: Geib, Rüdiger <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: Greg Mirsky <[email-masked]>
Date: Thu, 16 Nov 2017 22:39:06 +0800

Hi John,
if network doesn't use payload information to handle ECMP then performance
measurement using RFC 8169-style or pure active OAM based on RFC 6374 will
certainly work. But if it is DPI-based hashing for ECMP, then there cannot
be guarantee that packets with GAL/G-ACh follow the same path as regular
packets. Of course, one can use GAL/G-ACh encapsulation as a tunnel, as
normal case and then do any sort of measurements.

Regards,
Greg

On Thu, Nov 16, 2017 at 7:59 PM, John E Drake <[email-masked]> wrote:

> Ruediger,
>
>
>
> There is also the possibility of using a GAL w/ a new fixed size GACH
> containing the SR Segment List Id.  This is similar to Robert’s suggestion
> of using a VXLAN header.
>
>
>
> Yours Irrespectively,
>
>
>
> John
>
>
>
> *From:* mpls [mailto:[email-masked]] *On Behalf Of *
> [email-masked]
> *Sent:* Thursday, November 16, 2017 4:44 AM
> *To:* [email-masked]
> *Cc:* [email-masked];
> [email-masked]; [email-masked]; [email-masked]; [email-masked]
> *Subject:* Re: [mpls] [spring] redux: Special purpose labels in
> draft-hegde-spring-traffic-accounting-for-sr-paths
>
>
>
> Adrian,
>
>
>
> to me, there’s no ideal solution. But an analysis may help to find a
> useful solution. There’s a need to collect traffic statistics also for
> packets which don’t follow the shortest end to end path. There’s no simple
> howto, I think.
>
>
>
> -        Acoounting of a subset of labels only (e.g. Node-SID Labels and
> Anycast-SID, but not ADJ-SID). The idea is a compromise to limit the number
> of counters be maintained. Consider accounting of the top 2 labels carrying
> global routing information.
>
> -        A special label. Shradda proposes to put such a label into the
> stack. The labels present there prior to the addition are maintained. One
> might think about a single top label which identifies and replaces the
> label stack carrying routing information relevant for the path. That would
> simplify accounting, but it requires suitable IGP functionality.
>
>
>
> *Von:* spring [mailto:[email-masked] <[email-masked]>] *Im
> Auftrag von *Adrian Farrel
> *Gesendet:* Donnerstag, 16. November 2017 06:35
> *An:* 'Mach Chen' <[email-masked]>; 'Jeff Tantsura' <
> [email-masked]>; 'Robert Raszuk' <[email-masked]>
> *Cc:* 'draft-hegde-spring-traffic-accounting-for-sr-paths' <
> [email-masked]>; 'spring' <
> [email-masked]>; 'Zafar Ali (zali)' <[email-masked]>; 'mpls' <
> [email-masked]>
> *Betreff:* Re: [spring] [mpls] redux: Special purpose labels in
> draft-hegde-spring-traffic-accounting-for-sr-paths
>
>
>
> _______________________________________________
> mpls mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/mpls
>
>

---

From: "Dongjie (Jimmy)" <[email-masked]>
Date: Thu, 16 Nov 2017 15:26:19 +0000

Hi Robert,

When you say “no marker of any sort is needed”,  I think actually you mean to use the markers in another layer, e.g. the IP layer.

In a layered network, IMO each layer (Ethernet, MPLS, IP, etc.) needs its own OAM mechanisms. For example, we cannot use Ethernet OAM to replace IP OAM☺

Best regards,
Jie

From: mpls [mailto:[email-masked]] On Behalf Of Robert Raszuk
Sent: Thursday, November 16, 2017 3:08 PM
To: Adrian Farrel
Cc: draft-hegde-spring-traffic-accounting-for-sr-paths; spring; mpls; Zafar Ali (zali)
Subject: Re: [mpls] [spring] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Adrian

And debugging LDP networks is no different then debugging IP networks so sure some who are used to ATM/Frame Relay find it very hard to troubleshoot.

Best
r.

On Nov 16, 2017 13:35, "Adrian Farrel" <[email-masked]<mailto:[email-masked]>> wrote:
Let's unpick a couple of things...

Adrian

---

From: David Allan I <[email-masked]>
Date: Fri, 17 Nov 2017 03:26:14 +0000

Would not the concept of

<forwarding labels><GAL><id>(EOS set)<payload>

Get a bit strange?  We are simply swapping one reserved label for another…

Dave

Sent: Thursday, November 16, 2017 8:00 PM

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: John E Drake <[email-masked]>
Date: Fri, 17 Nov 2017 04:02:16 +0000

Dave,

I think the EoS bit is set in the GAL.  I.e., there would be a small fixed size identifier between the stack and the payload.  As I indicated it’s just a suggestion.

Yours Irrespectively,

John

From: David Allan I [mailto:[email-masked]]
Sent: Thursday, November 16, 2017 10:26 PM
To: John E Drake <[email-masked]>; Ext - [email-masked] <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: RE: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Would not the concept of

Dave

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: David Allan I <[email-masked]>
Date: Fri, 17 Nov 2017 04:07:46 +0000

You’re right, my issue was the semantics of the GAL being that of a termination and not a shim…. Would be strange to change that such that the stack could continue after it.

Dave

From: John E Drake [mailto:[email-masked]]
Sent: Friday, November 17, 2017 12:02 PM
To: David Allan I <[email-masked]>; Ext - [email-masked] <[email-masked]>; [email-masked]
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; [email-masked]
Subject: RE: [spring] [mpls] redux: Special purpose labels in draft-hegde-spring-traffic-accounting-for-sr-paths

Dave,

Yours Irrespectively,

John

To: John E Drake <[email-masked]<mailto:[email-masked]>>; Ext - [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>; [email-masked]<mailto:[email-masked]>

Would not the concept of

Dave

Ruediger,

Yours Irrespectively,

John

Adrian,

Regards, Ruediger

Adrian

---

From: Greg Mirsky <[email-masked]>
Date: Fri, 17 Nov 2017 12:53:52 +0800

Hi John, et. al,
GAL may be placed anywhere in the stack, not only at the BoS. That was
re-affirmed by RFC 6423 that extended applicability of the GAL to PWs. Thus
GAL indicates that the ACH immediately follows the label stack, i.e. what
ever label has S bit set. Resulting from that, I think, we may set GAL
multiple times in SR-MPLS stack to work around the RLD syndrome. Yes, it is
bump-in-a-wire with ACH.

Regards,
Greg

On Fri, Nov 17, 2017 at 12:02 PM, John E Drake <[email-masked]> wrote:

> Dave,
>
>
>
> I think the EoS bit is set in the GAL.  I.e., there would be a small fixed
> size identifier between the stack and the payload.  As I indicated it’s
> just a suggestion.
>
>
>
> Yours Irrespectively,
>
>
>
> John
>
>
>
> *From:* David Allan I [mailto:[email-masked]]
> *Sent:* Thursday, November 16, 2017 10:26 PM
> *To:* John E Drake <[email-masked]>; Ext - [email-masked] <
> [email-masked]>; [email-masked]
> [email-masked]; [email-masked]; [email-masked]; [email-masked]
> *Subject:* RE: [spring] [mpls] redux: Special purpose labels in
> *From:* spring [mailto:[email-masked] <[email-masked]>] *On
> Behalf Of *John E Drake
> *Sent:* Thursday, November 16, 2017 8:00 PM
> *To:* Ext - [email-masked] <[email-masked]>;
> [email-masked]
> [email-masked]; [email-masked]; [email-masked]; [email-masked]
> *Subject:* Re: [spring] [mpls] redux: Special purpose labels in
> *From:* mpls [mailto:[email-masked] <[email-masked]>] *On
> Behalf Of [email-masked]